package control.factory;
 
import java.util.Locale;
import java.util.ResourceBundle;

/*
 * **************************************************************************
 *  <p>MessageFactory factory class
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class MessageFactory 
{
	//system global messages...
	
	public static String system_error_emptyValue = "system.error.emptyValue";

	public static String system_error_invalidFormat = "system.error.invalidFormat";

	public static String system_error_persistenceError = "system.error.persistenceError";

	public static String system_error_parameterNotFound = "system.error.parameterNotFound";
	
	//System global texts...
	
	public static String table_label_pagesShowed = "system.global.pagesShowed";

	public static String table_label_registriesShowed = "system.global.registriesShowed";

	public static String label_queryCriteria = "system.global.queryCriteria";

	public static String label_error_mandatoryField = "system.error.mandatoryField";

	public static String label_error_dateFormat = "system.error.dateFormat";

	public static String label_error_dateRange = "system.error.dateRange";
	
	//SCR0001: Login & RestorePassword use cases...
	
	public static String system_login_success = "system.scr0001.error.success";

	public static String system_login_error_unknownUser = "system.scr0001.error.unknownUser";

	public static String system_login_error_useridHasWrongFormat = "system.scr0001.error.useridHasWrongFormat";

	public static String system_login_error_passwordHasWrongFormat = "system.scr0001.error.passwordHasWrongFormat";

	public static String system_login_error_pageHasWrongFormat = "system.scr0001.error.pageHasWrongFormat";

	public static String system_login_error_wrongPassword = "system.scr0001.error.wrongPassword";

	public static String system_login_error_userIsBlocked = "system.scr0001.error.userIsBlocked";

	public static String system_login_error_userIsNotActive = "system.scr0001.error.userIsNotActive";

	public static String system_login_error_userHasNoEmailAddress = "system.scr0001.error.userHasNoEmailAddress";

	public static String system_login_error_couldNotSendEmail = "system.scr0001.error.couldNotSendEmail";

	public static String system_login_label_mailsubject = "system.scr0001.label.regeneratepassword.mailsubject";

	public static String system_login_label_mailbody = "system.scr0001.label.regeneratepassword.mailbody";
		
	//SCR0003: MaintenanceUsers use case...
	
	public static String system_maintenanceusers_label_userid = "qssh.indicadores.scr0003.label.userid";

	public static String system_maintenanceusers_label_name = "qssh.indicadores.scr0003.label.name";

	public static String system_maintenanceusers_label_surname1 = "qssh.indicadores.scr0003.label.surname1";

	public static String system_maintenanceusers_label_surname2 = "qssh.indicadores.scr0003.label.surname2";

	public static String system_maintenanceusers_label_email  = "qssh.indicadores.scr0003.label.email";

	public static String system_maintenanceusers_label_isactive = "qssh.indicadores.scr0003.label.isactive";

	public static String system_maintenanceusers_success = "qssh.indicadores.scr0003.error.success";

	public static String system_maintenanceusers_error_noAvailableUsers = "qssh.indicadores.scr0003.error.noAvailableUsers";

	public static String usecase_maintenanceusers_error_persistence = "qssh.indicadores.scr0003.error.persistence";

	//SCR0004: EditUser use case...

	public static String system_edituser_success = "qssh.indicadores.scr0004.error.success";

	public static String system_edituser_error_unknownUser = "qssh.indicadores.scr0004.error.unknownUser";

	public static String system_edituser_error_persistence = "qssh.indicadores.scr0004.error.persistence";

	public static String system_edituser_error_alreadyExists = "qssh.indicadores.scr0004.error.alreadyExists";

	public static String system_edituser_error_useridHasWrongFormat = "qssh.indicadores.scr0004.error.useridHasWrongFormat";

	public static String system_edituser_error_passwordHasWrongFormat = "qssh.indicadores.scr0004.error.passwordHasWrongFormat";

	public static String system_edituser_error_prileNotSelected = "qssh.indicadores.scr0004.error.profileNotSelected";

	public static String system_edituser_error_cannotBuildBeanFromDto = "qssh.indicadores.scr0004.error.cannotBuildBeanFromDto";
	
	//SCR0005: EditPersonalData use case...
	
	public static String system_editpersonaldata_success = "qssh.indicadores.scr0005.error.success";

	public static String system_editpersonaldata_error_unknownUser = "qssh.indicadores.scr0005.error.unknownUser";

	public static String system_editpersonaldata_error_persistence = "qssh.indicadores.scr0005.error.persistence";

	public static String system_editpersonaldata_error_useridHasWrongFormat = "qssh.indicadores.scr0005.error.useridHasWrongFormat";

	public static String system_editpersonaldata_error_passwordHasWrongFormat = "qssh.indicadores.scr0005.error.passwordHasWrongFormat";

	public static String system_editpersonaldata_error_pageHasWrongFormat = "qssh.indicadores.scr0005.error.pageHasWrongFormat";

	public static String system_editpersonaldata_error_phoneHasWrongFormat = "qssh.indicadores.scr0005.error.phoneHasWrongFormat";

	public static String system_editpersonaldata_error_emailHasWrongFormat = "qssh.indicadores.scr0005.error.emailHasWrongFormat";

	public static String system_editpersonaldata_error_cannotBuildBeanFromDto = "qssh.indicadores.scr0005.error.cannotBuildBeanFromDto";

	public static String system_editpersonaldata_error_invalidPasswordConfirmation = "qssh.indicadores.scr0005.error.invalidPasswordConfirmation";
	
	//translation function...
		
	public static String translate(String text, String language){
		
		if (text == null || text.trim().length()==0)
			return "";
			
		Locale locale = null;	
		if (language!=null){
			locale = new Locale(language,"");
		}
		else{
			locale = new Locale("es","");
		}
		
		if (locale==null){
			System.out.println("Error,I Cant create language "+language);
			return null; 
		}
		
		ResourceBundle bundle = ResourceBundle.getBundle("qssh.indicadores.control.navigation.resources",locale);
		 
		String returnText = text;
		
		try
		{
			returnText = bundle.getString(text);
		}
		catch (java.util.MissingResourceException e)
		{
			System.out.println(e.getMessage());
		}
		
		return returnText;	
	}
}
