package control.factory;

import java.lang.reflect.Constructor;

import control.interfaces.UseCase;
import control.utility.ApplicationStore;
import control.utility.Logger;
import entity.Dictionary;

/*
 * **************************************************************************
 *  <p>UseCaseFactory factory class
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
 
public class UseCaseFactory {

	public static UseCase makeUseCase(ApplicationStore as,Dictionary dicc, String useCaseName){
		try
		{
			Class useCaseClass = Class.forName(useCaseName.trim());
					
			Class constructorClassParameters [] = { ApplicationStore.class, Dictionary.class }; 
			Object constructorObjectParameters [] = { as, dicc };
					 
			Constructor c = useCaseClass.getConstructor(constructorClassParameters);
			
			UseCase recoveredUseCase = (UseCase) c.newInstance(constructorObjectParameters);					
			//recoveredUseCase.start();
			
			return recoveredUseCase;
		}
		catch(Exception exc)
		{
			exc.printStackTrace();
			Logger.log("QSSH Indicadores >> EventProcessor >> processMenuEvent >> Error make instance of "+useCaseName);
			return null;
		}
	}

}
