package control.utility;

import java.util.Date;

/*
 * **************************************************************************
 *  <p>ApplicationError entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */

public class ApplicationError {
	
	/*******************************************************************
	 * 	CODE ERROR CONSTANTS
	 *******************************************************************/
	public static final int NO_ERROR = 0;
	public static final int EMPTY_MANDATORY_FIELD = 1;
	public static final int WRONG_FORMAT = 2;
	public static final int NEGATIVE_VALUE = 3;	
	public static final int INTERNAL_APPLICATION_ERROR = 4;
	public static final int USER_PASSWORD_INCORRECT = 5;
	public static final int USER_NEW_PASSWORD_INCORRECT = 6;
	public static final int NO_DATES = 7;
	public static final int FORMAT_DATES = 8;
	public static final int USER_ALTA_EXIST = 9;
	
	private int _code;	
	private Date _date;	
	private String _messageId; 	
	private String _origin;
	private Object [] _messageParameters; 
	
	public ApplicationError(String messageId, int code) {
		_code = code;
		_messageId = messageId;	
	}

	public ApplicationError(String messageId, int code, Object [] messageParameters) 
	{
		_code = code;
		_messageId = messageId;	
		_messageParameters = messageParameters;		
	}

	public ApplicationError(int code, String messageId, String origin, Date date, Object [] messageParameters) {
		_code = code;
		_origin = origin;
		_date = date;
		_messageId = messageId;
		_messageParameters = messageParameters;		
	}

	public void setCode(int code) {
		_code = code;
	}

	public void setMessageId(String messageId) {
		_messageId = messageId;
	}

	public void setDate(Date date) {
		_date = date;
	}

	public void setOrigin(String origin) {
		_origin = origin;
	}

	public ApplicationError(int code, String messageId, String origin, Date date) {
		_code = code;
		_origin = origin;
		_date = date;
		_messageId = messageId;
	}

	public int getCode() {
		return _code;
	}

	public Date getDate() {
		return _date;
	}

	public String getMessageId() {
		return _messageId;
	}

	public String getOrigin() {
		return _origin;
	}

	public Object[] getMessageParameters() {
		return _messageParameters;
	}

	public void setMessageParameters(Object[] objects) {
		_messageParameters = objects;
	}
}

