package control.utility;

import java.util.ArrayList;
import java.util.Arrays;

import control.interfaces.UseCase;

import entity.Dto;

/*
 * **************************************************************************
 * <p>ApplicationEvent entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class ApplicationEvent {
	
	private UseCase _activeUseCase = null;
	private Dto _dto = null;
	private String _target;	
	private ArrayList _applicationErrors = new ArrayList();
	private ArrayList _temporalImageFileName = new ArrayList();
	private String _temporalFile = null;
	private String _xmlResponse = null;

	public String getXmlResponse() {
		return _xmlResponse;
	}

	public void setXmlResponse(String response) {
		_xmlResponse = response;
	}

	public UseCase getActiveUseCase() {
		return _activeUseCase;
	}

	public Dto getDto() {
		return _dto;
	}

	public void setActiveUseCase(UseCase useCase) {
		_activeUseCase = useCase;
	}

	public void setDataModel(Dto dto) {
		_dto = dto;
	}

	public String getTarget() {
		return _target;
	}

	public void setTarget(String target) {
		_target = target;
	}

	public ArrayList getApplicationErrors() {
		return _applicationErrors;
	}

	public void addApplicationErrors(ApplicationError appError) {
		_applicationErrors.add(appError);
	}

	public void addApplicationErrors(ApplicationError[] appErrors) {
		_applicationErrors.addAll(Arrays.asList(appErrors));
	}
	
	public void setApplicationErrors(ApplicationError[] appErrors) {
		_applicationErrors = new ArrayList();
		_applicationErrors.addAll(Arrays.asList(appErrors));
	}

	public void setApplicationErrors(ArrayList list) {
		_applicationErrors = list;
	}
	
	public void cleanErrors(){
		_applicationErrors = new ArrayList();
	}
	
	
	public void cleanTemporalyImageFileName(){
		_temporalImageFileName.clear();
	}
     
	public String getTemporalyImageFileName(int i) {
		return _temporalImageFileName.get(i).toString();
	}
	
	public String getTemporalyImageFileName() {
		return _temporalImageFileName.get(0).toString();
	}

	public void setTemporalyImageFileName(String tempFile) {
		_temporalImageFileName.add(tempFile);
	}
	
	public int getTemporalFilesImageNameSize(){
		return _temporalImageFileName.size(); 
	}
	
	public void setTemporalFile(String tempFile) {
		_temporalFile = tempFile;
	}

	 public String getTemporalFile() {
		return _temporalFile ;
	} 
}
