package control.utility;

import javax.servlet.http.HttpSession;

/*
 * **************************************************************************
 * <p>ApplicationStore entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */

public class ApplicationStore {
	
	private HttpSession _session = null;

	public ApplicationStore(HttpSession sesion) {
		_session = sesion;
	}
	
	public void addObject(String name, Object o) {
		_session.setAttribute(name,o);
	}

	public Object getObject(String name) {
		return _session.getAttribute(name);
	}

	public void removeObject(String name) {
		_session.removeAttribute(name);
	}
	
	public void removeAll() {
		_session.invalidate();
	}

	public HttpSession getSession() {
		return _session;
	}

	public ApplicationEvent getEvent() {
		return (ApplicationEvent) getObject(ApplicationGlobals.SYSTEM_PARAM_ID_EVENT);
	}

	public void setSession(HttpSession session) {
		_session = session;
	}

	public void setEvent(ApplicationEvent event) {
		addObject(ApplicationGlobals.SYSTEM_PARAM_ID_EVENT, event);
	}
}
