package control.utility;
 
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/*
 * **************************************************************************
 *  <p>FileHelper entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class FileHelper 
{
	public static final String getContents(java.io.File f)
	{
		String retString = null;
		
		try
		{
			FileReader freader = new FileReader(f);
			
			long flength = f.length();
			
			char buffer[] = new char[(int) flength];
			if (freader.read(buffer) == flength)
			{
				retString = new String(buffer);
			}
			freader.close();
		}
		catch(IOException exc)
		{
		}
		
		return retString;
	}
	
	public static final byte [] getBinaryContents(java.io.File f)
	{
		byte [] retBytes = null;
		
		try
		{
			FileInputStream freader = new FileInputStream(f);
			
			long flength = f.length();
			
			byte buffer[] = new byte[(int) flength];
			if (freader.read(buffer) == flength)
			{
				retBytes = buffer;
			}
			freader.close();
		}
		catch(IOException exc)
		{
			exc.printStackTrace();
		}
		
		return retBytes;
	}
	
	public static final boolean setContents(java.io.File f, String chars)
	{
		boolean retCode = false;
		
		try
		{
			FileWriter fwriter = new FileWriter(f);
			fwriter.write(chars);
			fwriter.close();
			
			retCode = true;
		}
		catch(IOException exc)
		{
		}
		
		return retCode;
	}

	public static boolean setBinaryContents(java.io.File f, byte [] bytes)
	{
		boolean retCode = false;
		
		try
		{
			FileOutputStream fwriter = new FileOutputStream(f);
			fwriter.write(bytes);
			fwriter.flush();
			fwriter.close();
			
			retCode = true;
		}
		catch(IOException exc)
		{
		}
		
		return retCode;
	}

	public static final String getMimeType(File f)
	{
		String fname = f.getName();
		String mimeType = "plain/text";
		
		int dot = fname.indexOf(".");
		if (dot != -1  &&  dot < fname.length())
		{
			String extension = fname.substring(fname.indexOf(".") + 1).toUpperCase();
			if (extension.equals("DOC"))
			{
				mimeType = "application/msword";
			}
			else if (extension.equals("RTF"))
			{
				mimeType = "application/msword";
			}
			else if (extension.equals("TXT"))
			{
				mimeType = "application/msword";
			}
			else if (extension.equals("XLS"))
			{
				mimeType = "application/ms-excel";
			}
			else if (extension.equals("PDF"))
			{
				mimeType = "application/pdf";
			}
		}
		
		return mimeType;
	}
    
    public static BufferedReader openFile(File p_File_fichero)
    {
     // Abrimos el fichero con los cdigos de bastidores a importar.
     BufferedReader v_FileInputStream = null;

     try
     {
      FileReader fileReader = new FileReader(p_File_fichero);
      v_FileInputStream = new BufferedReader(fileReader);
     }
     catch (Exception e1)
     {
         return null;
     }
     return (v_FileInputStream);
    }

    public static void closeBufferFile(BufferedReader datosFichero)
    {
        try {         
            datosFichero.close();
        } catch (Exception e) {}
        
    }    
    
}
