package control.utility;

import java.util.ArrayList;
import java.util.Locale;

import entity.hibernate.Usuario;

/*
 * **************************************************************************
 * <p>Utility utility class
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */

public class Utility 
{
	//gets & sets the page size in this session...
	
	public static int getPageSize(ApplicationStore as)
	{
		Integer ps = (Integer) as.getObject(ApplicationGlobals.SYSTEM_PAGE_SIZE_IN_LIST);
		int pageSize = (ps == null? 16 : ps.intValue());
		return pageSize;
	}
	
	public static void setPageSize(ApplicationStore as, int pageSize)
	{
		Integer ps = new Integer(pageSize);
		as.addObject(ApplicationGlobals.SYSTEM_PAGE_SIZE_IN_LIST, ps);
	}
	
	//gets & sets the locale language in this session...
	
	public static String getLanguageAsString(ApplicationStore as)
	{
		String retString = null;		
		Locale l = (Locale) as.getObject(ApplicationGlobals.SYSTEM_LOCALE_LENGUAGE);
		
		if (l != null)
		{
			retString = l.getLanguage();
		}
		
		return retString;
	}
	
	public static Locale getLanguage(ApplicationStore as)
	{
		return (Locale) as.getObject(ApplicationGlobals.SYSTEM_LOCALE_LENGUAGE);
	}
	
	public static void setLanguage(ApplicationStore as, Locale language)
	{
		as.addObject(ApplicationGlobals.SYSTEM_LOCALE_LENGUAGE, language);
	}
	
	//gets & sets the logged user in this session...
	
	public static Usuario getLoggedUser(ApplicationStore as)
	{
		return (Usuario) as.getObject(BusinessGlobals.SYSTEM_LOGGED_USER_OBJECT);
	}
	
	public static void setLoggedUser(ApplicationStore as, Usuario user)
	{
		as.addObject(BusinessGlobals.SYSTEM_LOGGED_USER_OBJECT, user);
	}
	
	//gets & sets the list whith system languages...
	
	public static ArrayList getSystemLanguages(ApplicationStore as){
		return (ArrayList)as.getObject(ApplicationGlobals.SYSTEM_LANGUAGES_LIST);
	}
	
	public static void setSystemLanguages(ApplicationStore as, ArrayList languages){
		as.addObject(ApplicationGlobals.SYSTEM_LANGUAGES_LIST,languages); 
	}
	
}
