package database;

import java.sql.Blob;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import database.utility.CFiltro;
import database.utility.DaoException;
import database.utility.DatabaseDaoDb;
import entity.hibernate.Barrio;
import entity.hibernate.BarrioPK;
 
/*
 * **************************************************************************
 * <p>BarrioDaoDb dao class extends DatabaseDaoDb
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class BarrioDaoDb extends DatabaseDaoDb
{

	private java.sql.Connection _connection;
	private String DATABASE_SELECT = "SELECT * FROM BARRIOS"; 
	
	public static final String DB_IDZONA 	= "IdZona";
	public static final String DB_IDBARRIO 	= "IdBarrio";
	public static final String DB_DESCRIPCION = "Descripcion";
	public static final String DB_MAPA 	= "Mapa";	

	public BarrioDaoDb (java.sql.Connection connection) 
	{
		_connection = connection;      
	}
	
	public Vector consultar(CFiltro filtro, Vector orden) throws DaoException {
		String sentencia = DATABASE_SELECT;
		sentencia += DatabaseDaoDb.construirWhere (filtro);
		sentencia += DatabaseDaoDb.construirOrderBy (orden);		
		ResultSet srs = DatabaseDaoDb.createStatement(_connection, sentencia);
		return _obtenerDatosResultSet (srs);
	}
	
	public Vector consultar(CFiltro filtro) throws DaoException {
		String sentencia = DATABASE_SELECT;
		sentencia += DatabaseDaoDb.construirWhere (filtro);
		ResultSet srs = DatabaseDaoDb.createStatement(_connection, sentencia);
		return _obtenerDatosResultSet (srs);
	}
	
	public Vector consultar() throws DaoException {
		String sentencia = DATABASE_SELECT;
		ResultSet srs = DatabaseDaoDb.createStatement(_connection, sentencia);
		return _obtenerDatosResultSet (srs);
	}
	
	private Vector _obtenerDatosResultSet (ResultSet srs) throws DaoException {
		try {
			Vector retVector = new Vector();
			while (srs.next())	{
				int idZona = srs.getInt(DB_IDZONA);
				int idBarrio = srs.getInt(DB_IDBARRIO);
				String descripcion = srs.getString(DB_DESCRIPCION);
				Blob mapa = srs.getBlob(DB_MAPA);
				Barrio barrio = new Barrio (new BarrioPK(idZona, idBarrio), descripcion, mapa); 
				retVector.addElement(barrio);
			}
			return retVector;
		  
		} catch(SQLException ex) {
			throw new DaoException(DaoException.EXC_SQLException, ex.getMessage());
		}
	}

	public boolean insertar(Barrio barrio) throws DaoException {
		return false;
	}
	
	public boolean modificar(Barrio barrio) throws DaoException {
		return false;
	} 

	public boolean eliminar (Barrio barrio) throws DaoException {
		return false;
	} 
	
}