package database;
 
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import database.utility.CFiltro;
import database.utility.DaoException;
import database.utility.DatabaseDaoDb;
import entity.hibernate.Usuario;
 
/*
 * **************************************************************************
 * <p>SeguimientosDaoDb dao class extends HibernateDaoDb
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class SeguimientosDaoDb extends DatabaseDaoDb
{
	private java.sql.Connection _connection;
	private String DATABASE_SELECT = "SELECT * FROM SEGUIMIENTOS"; 
	private String DATABASE_INSERT = "INSERT INTO SEGUIMIENTOS (IdUsuario, IdUsuarioSeguir) VALUES (?,?)"; 

	public static final String DB_IDUSUARIO 		= "IdUsuario";
	public static final String DB_IDUSUARIOSEGUIR	= "IdUsuarioSeguir";

	public SeguimientosDaoDb (java.sql.Connection connection)
	{
		_connection = connection;   
	}
	
	public Vector consultar(CFiltro filtro, Vector orden) throws DaoException {
		String sentencia = DATABASE_SELECT;
		sentencia += DatabaseDaoDb.construirWhere (filtro);
		sentencia += DatabaseDaoDb.construirOrderBy (orden);		
		ResultSet srs = DatabaseDaoDb.createStatement(_connection, sentencia);
		return _obtenerDatosResultSet (srs);
	}
	
	public Vector consultar(CFiltro filtro) throws DaoException {
		String sentencia = DATABASE_SELECT;
		sentencia += DatabaseDaoDb.construirWhere (filtro);
		ResultSet srs = DatabaseDaoDb.createStatement(_connection, sentencia);
		return _obtenerDatosResultSet (srs);
	}
	
	public Vector consultar() throws DaoException {
		String sentencia = DATABASE_SELECT;
		ResultSet srs = DatabaseDaoDb.createStatement(_connection, sentencia);
		return _obtenerDatosResultSet (srs);
	}
	
	private Vector _obtenerDatosResultSet (ResultSet srs) throws DaoException {
		try {
			Vector retVector = new Vector();
			while (srs.next())	{
				int idUsuario = srs.getInt(DB_IDUSUARIO);
				int idUsuarioSeguir = srs.getInt(DB_IDUSUARIOSEGUIR);
				retVector.addElement(idUsuarioSeguir);
			}
			return retVector;
		  
		} catch(SQLException ex) {
			throw new DaoException(DaoException.EXC_SQLException, ex.getMessage());
		}
	}

	public boolean insert(Integer idUsuario, Integer idUsuarioSeguir) throws DaoException
	{
		boolean retCode = false;

		PreparedStatement stmt;
		try {
			stmt = _connection.prepareStatement(DATABASE_INSERT);
			
			stmt.setInt(1, idUsuario);
			stmt.setInt(2, idUsuarioSeguir);
			
			stmt.execute();
			retCode = true;
				
		} catch(SQLException ex) {
			throw new DaoException(DaoException.EXC_SQLException, ex.getMessage());
		}
		
		return retCode;
	}
	
	public boolean delete(Usuario entity) throws DaoException
	{
		return false;	
	}
	
	public boolean update(Usuario entity) throws DaoException
	{
		return false;	
	}
	
}