package database.utility;

import control.utility.ApplicationException;

/*
 * **************************************************************************
 * <p>DaoException entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class DaoException extends ApplicationException 
{

	private static final long serialVersionUID = -3080116917422840779L;
	public static int EXC_None 					= 0;
	public static int EXC_NotImplemented 		= 1;	
	public static int EXC_NotInitialized 		= 2;
	public static int EXC_UnexpectedParameter	= 3;
	public static int EXC_WrongFormat			= 4;
	public static int EXC_SQLException			= 5;
	public static int EXC_RegistroDuplicado		= 6;
	public static int EXC_RegistroInexistente	= 7;
	public static int EXC_CampoNotNULL			= 8;
	public static int EXC_ViolacionRI			= 9;
	public static int EXC_ExceedMaxSize			= 10;
	public static int EXC_ConstraintViolated	= 11;
	
	private int  _exceptionType = DaoException.EXC_None; 
	private Exception _embeddedException = null; 
	
	public DaoException()
	{
	    	 super();	
	}
	
	public DaoException(String message)
	{
			 super(message);	
	}
	
	public DaoException(int exceptionType)
	{
			super();
		 	_exceptionType = exceptionType;	
	}
	
	public DaoException(Exception embeddedException)
	{
			super();
			_embeddedException = embeddedException;	
	}
	
	public DaoException(Exception embeddedException, String message)
	{
			super(message);
			_embeddedException = embeddedException;	
	}
	
	public DaoException(int exceptionType, String message)
	{
			super(message);
			_exceptionType = exceptionType;	
	}
	
	public DaoException(int exceptionType, String message, Exception embeddedException)
	{
			super(message);
			_exceptionType = exceptionType;
			_embeddedException = embeddedException;
	}
	
	public int getExceptionType()
	{	
		return _exceptionType;
	}
	
	public Exception embeddedException()
	{	
		return _embeddedException;
	}
	
}
