package database.utility;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import javax.sql.DataSource;


/**
 * Fabrica DAO implementando persistencia sobre una conexin JDBC
 */
public class FabricaDAODatabase
{
   private java.sql.Connection _connection = null;
   
   public FabricaDAODatabase() 
   {    
   }
   
   public boolean createConnection() 
   {
   		destroyConnection();
	
	    try {
			Class.forName("com.mysql.jdbc.Driver");

			String url = "jdbc:mysql://localhost/aparbar";
			_connection = DriverManager.getConnection(url, "root", "hibernate");
			
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}		   	
	    return true;
   }
   
   public boolean createConnection(Connection connection) 
   {
		destroyConnection();
		_connection = connection;
		
		return true;
   }   
   
   public boolean setAutoCommitMode(boolean mode){
		
		if (_connection==null) return false;
		
		try{
			_connection.setAutoCommit(mode);
			return true;	
		}
		catch (SQLException e){
			System.out.println(e.getMessage());
			return false;
		}
   }
   
   public Connection getConnection(){
   		return _connection;
   }
   
   public boolean destroyConnection() 
   {
   		if (_connection != null)
   		{
			try {
	   			_connection.close();
	   			_connection = null;
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
   		}
	   	
		return true;
   }
   
   public boolean commit() 
  {
	   if (_connection != null)
	   {
		   try {
				_connection.commit();
		   } catch (SQLException e) {
			   e.printStackTrace();
			   return false;
		   }
	   }
   	
	   return true;
  }
  
   public boolean rollback() {
	
	  if (_connection != null)
	  {
		  try {
			  _connection.rollback();
		  } catch (SQLException e) {
			  e.printStackTrace();
			  return false;
		  }
	  }
   	
	  return true;
   }
   
 
}
