package database.utility;
 
import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;
import java.util.Hashtable;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.Expression;


import control.utility.ApplicationGlobals;
import control.utility.Logger;
import database.hibernate.HibernateDaoDb;
import entity.hibernate.Publicacion;
import entity.hibernate.Usuario;


/*
 * **************************************************************************
 * <p>SystemHibernateDaoDbUtility utility class
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class FabricaHibernateDaoDatabase 
{
	protected Session _session = null;
	
	public FabricaHibernateDaoDatabase(Session session)
	{
		_session = session;
	}
	
	public Session getSession(){
		return _session;
	}
	
	public boolean insert(Serializable entity)
	{
		if (_session == null)
			return false;
								
		boolean retCode = false;
		
		HibernateDaoDb dao = new HibernateDaoDb(_session);
	 
		try
		{
			//recover data from database...
			
			retCode = dao.insert(entity); 
		}
		catch(DaoException e)
		{
			e.printStackTrace();
		}
		
		return retCode;
	}
	
	public boolean update(Serializable entity)
	{
		if (_session == null)
			return false;
								
		boolean retCode = false;
		
		HibernateDaoDb dao = new HibernateDaoDb(_session);
	 
		try
		{
			//recover data from database...
			
			retCode = dao.update(entity); 
		}
		catch(DaoException e)
		{
			e.printStackTrace();
		}
		
		return retCode;
	}

	public boolean delete(Serializable entity)
	{
		if (_session == null)
			return false;
								
		boolean retCode = false;
		
		HibernateDaoDb dao = new HibernateDaoDb(_session);
	 
		try
		{
			//recover data from database...
			
			retCode = dao.update(entity); 
		}
		catch(DaoException e)
		{
			e.printStackTrace();
		}
		
		return retCode;
	}
	public List retrieve(Criteria filter)
	{ 
		List result = null;
	
		if (_session == null)
			return null;
								
		HibernateDaoDb dao = new HibernateDaoDb(_session);
	 
		try
		{
			//recover data from database...
			
			result = dao.retrieve(filter); 
		}
		catch(DaoException e)
		{
			e.printStackTrace();
		}
		
		return result;
	}	
		
	public List querys(String  hql)
	{
		List result = null;
	    		 
		try
		{
			Query query = _session.createQuery(hql);				 
			result = query.list();
		}
		catch(HibernateException e)
		{
			e.printStackTrace();
		}
		
		return result;   
	}
	
}