package entity.hibernate;

import java.io.Serializable;
import java.sql.Blob;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/*
 * **************************************************************************
 *  <p>Publicacion entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Hibernate CodeGenerator
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class Publicacion implements Serializable {

	private static final long serialVersionUID = 8299800961411022212L;

	/** identifier field */
	private Integer idUsuario;

	/** persistent field */
	private Integer idPublicacion;
	
	/** persistent field */
	private Date fechaPublicacion;
	
	/** persistent field */
	private String texto;
	
	/** persistent field */
	private Blob imagen;
	
	/** persistent field */
	private String link;
	
	/** persistent field */
	private Integer idZona;
	
	/** persistent field */
	private Integer idBarrio;
	
	/** persistent field */
	private String direccion;

	private List listaComentarios;
	
	private Zona zona;
	
	private Barrio barrio;
	
	private Usuario usuario;

	/** full constructor */
    public Publicacion(Integer idUsuario, Integer idPublicacion, Date fechaPublicacion, String texto, Blob imagen, String link, Integer idZona, Integer idBarrio, String direccion) {
        this.idUsuario = idUsuario;
        this.idPublicacion = idPublicacion;
        this.fechaPublicacion = fechaPublicacion;
        this.texto = texto;
 		this.imagen = imagen;       
		this.link = link;
		this.idZona = idZona;
		this.idBarrio = idBarrio;
		this.direccion = direccion;
    }
    
	/** full constructor */
    public Publicacion(Integer idUsuario, Integer idPublicacion, Date fechaPublicacion, String texto, Blob imagen, String link, Zona zona, Barrio barrio, String direccion, List listaComentarios) {
        this.idUsuario = idUsuario;
        this.idPublicacion = idPublicacion;
        this.fechaPublicacion = fechaPublicacion;
        this.texto = texto;
 		this.imagen = imagen;       
		this.link = link;
		this.zona = zona;
		this.barrio = barrio;
		this.direccion = direccion;
		this.listaComentarios = listaComentarios;
    }

	/** PK constructor */
	public Publicacion(Integer idPublicacion) {
        this.idPublicacion = idPublicacion;

	}
    /** default constructor */
    public Publicacion() {
    }

	public Integer getIdUsuario() {
		return idUsuario;
	}

	public void setIdUsuario(Integer integer) {
		idUsuario = integer;
	}

	public Integer getIdPublicacion() {
		return idPublicacion;
	}
	
	public void setIdPublicacion(Integer integer) {
		idPublicacion = integer;
	}
	
	public Date getFechaPublicacion() {
		return fechaPublicacion;
	}

	public void setFechaPublicacion(Date date) {
		fechaPublicacion = date;
	}

	public String getTexto() {
		return texto;
	}

	public void setTexto(String string) {
		texto = string;
	}

	public Blob getImagen() {
		return imagen;
	}

	public void setImagen(Blob blob) {
		imagen = blob;
	}

	public String getLink() {
		return link;
	}

	public void setLink(String string) {
		link = string;
	}

	public Integer getIdZona() {
		return idZona;
	}

	public void setIdZona(Integer idZona) {
		this.idZona = idZona;
	}

	public Integer getIdBarrio() {
		return idBarrio;
	}

	public void setIdBarrio(Integer idBarrio) {
		this.idBarrio = idBarrio;
	}
	
	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String string) {
		direccion = string;
	}

	public List getListaComentarios() {
		return listaComentarios;
	}

	public void setListaComentarios(List list) {
		listaComentarios = list;
	}

	public Zona getZona() {
		return zona;
	}

	public void setZona(Zona zona) {
		this.zona = zona;
	}

	public Barrio getBarrio() {
		return barrio;
	}

	public void setBarrio(Barrio barrio) {
		this.barrio = barrio;
	}
	
	public Usuario getUsuario() {
		return usuario;
	}

	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	public boolean equals(Object other) {
		if ( (this == other ) ) return true;
		if ( !(other instanceof Publicacion) ) return false;
		Publicacion castOther = (Publicacion) other;
		return new EqualsBuilder()
			.append(this.getIdPublicacion(), castOther.getIdPublicacion())
			.isEquals();
	}

	public int hashCode() {
		return new HashCodeBuilder()
			.append(getIdUsuario())
			.append(getIdPublicacion())
			.append(getFechaPublicacion())
			.append(getTexto())
			.append(getImagen())
			.append(getLink())
			.append(getZona())
			.append(getBarrio())
			.append(getDireccion())
			.append(getListaComentarios())
			.toHashCode();
	}

	public String toString() {
		return new ToStringBuilder(this)
			.append("idPublicacion", getIdPublicacion())
			.toString();
	}


}
