package entity.hibernate;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/*
 * **************************************************************************
 *  <p>Usuario entity
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Hibernate CodeGenerator
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class Usuario implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = -8862844524191012821L;

	/** identifier field */
    private Integer idUsuario;

    /** persistent field */
    private String pasword;
	
	/** persistent field */
	private String tipoUsuario;
	
    /** nullable persistent field */
    private String nombre;

    /** nullable persistent field */
    private String apellidos;

    /** nullable persistent field */
    private Date fechaNacimiento;

    /** nullable persistent field */
    private String direccion;

    /** nullable persistent field */
    private String codigoPostal;
    
	/** nullable persistent field */
	private String pais;
	
    /** persistent field */
    private String email;

	/** nullable persistent field */   
	private List listaSeguimientos;
	
	/** nullable persistent field */   
	private List listaSeguidores;

	/** nullable persistent field */   
	private List listaPublicaciones;

	/** nullable persistent field */   
	private List listaComentarios;

	/** full constructor */
    public Usuario(Integer idUsuario, String pasword, String tipoUsuario, String nombre, String apellidos, 
    			   Date fechaNacimiento, String direccion, String codigoPostal, String pais, String email) {
        this.idUsuario = idUsuario;
        this.pasword = pasword;
        this.tipoUsuario = tipoUsuario;
        this.nombre = nombre;
        this.apellidos = apellidos;
        this.fechaNacimiento = fechaNacimiento;
        this.direccion = direccion;
        this.codigoPostal = codigoPostal;
        this.pais = pais;
        this.email = email;
    }
    
	/** PK constructor */
    public Usuario(Integer idUsuario) {
        this.idUsuario = idUsuario;
    }
    
    /** full constructor */
    public Usuario(Integer idUsuario, String pasword, String tipoUsuario, String nombre, String apellidos, 
    			   Date fechaNacimiento, String direccion, String codigoPostal, String pais, String email, 
    			   List listaSeguimientos, List listaSeguidores, List listaPublicaciones, List listaComentarios) {
        this.idUsuario = idUsuario;
        this.pasword = pasword;
        this.tipoUsuario = tipoUsuario;
        this.nombre = nombre;
        this.apellidos = apellidos;
        this.fechaNacimiento = fechaNacimiento;
        this.direccion = direccion;
        this.codigoPostal = codigoPostal;
        this.pais = pais;
        this.email = email;
        this.listaSeguimientos = listaSeguimientos;
		this.listaSeguidores = listaSeguidores;
		this.listaPublicaciones = listaPublicaciones;
		this.listaComentarios = listaComentarios;
    }

    /** default constructor */
    public Usuario() {
    }

	public Integer getIdUsuario() {
		return idUsuario;
	}

	public void setIdUsuario(Integer integer) {
		idUsuario = integer;
	}

	public String getPasword() {
		return pasword;
	}

	public void setPasword(String string) {
		pasword = string;
	}

	public String getTipoUsuario() {
		return tipoUsuario;
	}

	public void setTipoUsuario(String string) {
		tipoUsuario = string;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String string) {
		nombre = string;
	}

	public String getApellidos() {
		return apellidos;
	}

	public void setApellidos(String string) {
		apellidos = string;
	}
	
	public Date getFechaNacimiento() {
		return fechaNacimiento;
	}

	public void setFechaNacimiento(Date date) {
		fechaNacimiento = date;
	}

	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String string) {
		direccion = string;
	}

	public String getCodigoPostal() {
		return codigoPostal;
	}

	public void setCodigoPostal(String string) {
		codigoPostal = string;
	}
	
	public String getPais() {
		return pais;
	}

	public void setPais(String string) {
		pais = string;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String string) {
		email = string;
	}

	public List getListaSeguimientos() {
		return listaSeguimientos;
	}

	public void setListaSeguimientos(List list) {
		listaSeguimientos = list;
	}

	public List getListaSeguidores() {
		return listaSeguidores;
	}

	public void setListaSeguidores(List list) {
		listaSeguidores = list;
	}

	public List getListaPublicaciones() {
		return listaPublicaciones;
	}

	public void setListaPublicaciones(List list) {
		listaPublicaciones = list;
	}

	public List getListaComentarios() {
		return listaComentarios;
	}

	public void setListaComentarios(List list) {
		listaComentarios = list;
	}

	public boolean equals(Object other) {
		if ( (this == other ) ) return true;
		if ( !(other instanceof Usuario) ) return false;
		Usuario castOther = (Usuario) other;
		return new EqualsBuilder()
			.append(this.getIdUsuario(), castOther.getIdUsuario())
			.isEquals();
	}

	public int hashCode() {
		return new HashCodeBuilder()
			.append(getIdUsuario())
			.append(getPasword())
			.append(getTipoUsuario())
			.append(getNombre())
			.append(getApellidos())
			.append(getFechaNacimiento())
			.append(getDireccion())
			.append(getCodigoPostal())
			.append(getPais())
			.append(getEmail())
			.toHashCode();
	}

	public String toString() {
		return new ToStringBuilder(this)
			.append("idUsuario", getIdUsuario())
			.toString();
	}

}
