package usecase;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import control.utility.ApplicationException;
import entity.hibernate.Barrio;
import entity.hibernate.BarrioPK;
import entity.hibernate.Comentario;
import entity.hibernate.Publicacion;
import entity.hibernate.Usuario;
import entity.hibernate.Zona;

public class Prototype {
	
	private static List usuarios = new ArrayList();
	
	private static List zonas = new ArrayList();
	private static List barrios = new ArrayList();
	
	private static List publicaciones = new ArrayList();
	private static List comentarios = new ArrayList();
	
	public static void init(){
		
		if (usuarios.isEmpty()) {
			
			Barrio barrio73 = new Barrio(new BarrioPK(10,73), "La Verneda i la Pau", null, null);
			List listaBarrios10 = new ArrayList();
			listaBarrios10.add(barrio73);
			Zona zona10 = new Zona(10, "Distrito 10: Sant Mart", null, listaBarrios10);
			
			zonas.add(zona10);
			barrios.add(barrio73);
			
			SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
			SimpleDateFormat dtf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");

			
			try {
				Date date1 = dtf.parse("2013-05-12 10:00:00");
				Date date2 = dtf.parse("2013-05-12 10:10:00");
				Date date3 = dtf.parse("2013-05-12 11:00:00");
				Date date4 = dtf.parse("2013-05-12 11:10:00");
				Date dateAinhoa = df.parse("1989-08-13");
				Date dateFina = df.parse("1970-03-07");
				
				List listaComentariosPublicacion2 = new ArrayList();
				Comentario comentario2 = new Comentario(2,2, 1, date4, "genial muchas gracias lo probar");
				listaComentariosPublicacion2.add(comentario2);
			
				List listaSeguimientos2 = new ArrayList();
				List listaSeguidores2 = new ArrayList();
				List listaPublicaciones2 = new ArrayList();
				Publicacion publicacion1 = new Publicacion(1,1,date3, "he encontrado una zona donde aparcar en la entrada de Barcelona y despus poder desplazarte en metro", null, "link", zona10, barrio73, "metro la pau", listaComentariosPublicacion2);
				listaPublicaciones2.add(publicacion1);
				List listaComentarios2 = new ArrayList();
				Usuario user2 = new Usuario(2,"ainhoa", "U", "Ainhoa", "Olivares Cara", dateAinhoa, "Av. Canaletas 37 44", "08290", "Espaa", "ainhoaolivares@gmail.com", listaSeguimientos2, listaSeguidores2, listaPublicaciones2, listaComentarios2);
	
				List listaSeguimientos = new ArrayList();
				listaSeguimientos.add(user2);
				List listaSeguidores = new ArrayList();
				List listaComentariosPublicacion1 = new ArrayList();
				Comentario comentario1 = new Comentario(1,1, 2, date2, "yo si se, ahora te publico la info");
				listaComentariosPublicacion1.add(comentario1);
				List listaPublicaciones = new ArrayList();
				Publicacion publicacion2 = new Publicacion(1,1, date1, "alguien sabe de algun parking para aparcar en la zona de la Pau", null, "link", zona10, barrio73, "Av. Guipuzcoa", listaComentariosPublicacion1);
				listaPublicaciones.add(publicacion2);
				List listaComentarios = new ArrayList();
				
				Usuario user1 = new Usuario(1,"fina", "U", "Fina", "Cara Fernandez", dateFina, "Av. Canaletas 37 44", "08290", "Espaa", "fcf0735@gmail.com", listaSeguimientos, listaSeguidores, listaPublicaciones, listaComentarios);
			
				listaSeguidores2.add(user1);
				user2.setListaSeguidores(listaSeguidores2);
				
				usuarios.add(user1);
				usuarios.add(user2);
				publicaciones.add(publicacion1);
				publicaciones.add(publicacion2);
				comentarios.add(comentario1);
				comentarios.add(comentario2);
				
			} catch (ParseException e) {
				e.printStackTrace();
			}				

		}
	}

	public static Usuario retrieveUser(String email) throws ApplicationException 
	{
		Usuario retUser = null;
		
		Iterator us = usuarios.iterator();
		while (us.hasNext()) {
			Usuario user = (Usuario)us.next();
			if (email.equals(user.getEmail())) {
				retUser = user;
				break;
			}
		}
		
		return retUser;
	}
	
	public static Usuario retrieveUser(Integer userId) throws ApplicationException 
	{
		Usuario retUser = null;
		
		Iterator us = usuarios.iterator();
		while (us.hasNext()) {
			Usuario user = (Usuario)us.next();
			if (userId.equals(user.getIdUsuario())) {
				retUser = user;
				break;
			}
		}
		
		return retUser;
	}
	
	public static List retrieveUsuarios() throws ApplicationException 
	{
		return usuarios;
	}
	
	public static List retrieveZonas() throws ApplicationException 
	{
		return zonas;
	}
	
	public static List retrieveBarrios() throws ApplicationException 
	{
		return barrios;
	}
	
	public static List retrieveSeguimientos(Integer userId) throws ApplicationException 
	{
		List retListaSeguimientos = new ArrayList();
		
		Usuario user = retrieveUser(userId);
		if (user != null) {
			retListaSeguimientos = user.getListaSeguimientos();
		}
		
		return retListaSeguimientos;
	}

	public static Publicacion retrievePublicacion(Integer idPublicacion) throws ApplicationException 
	{
		Publicacion retPublicacion = null;
		
		Iterator it = publicaciones.iterator();
		while (it.hasNext()) {
			Publicacion publicacion = (Publicacion)it.next();
			if (idPublicacion.equals(publicacion.getIdPublicacion())) {
				retPublicacion = publicacion;
				break;
			}
		}
		
		return retPublicacion;
	}
	
	public static List retrievePublicaciones(Integer userId) throws ApplicationException 
	{
		List retListaPublicaciones = new ArrayList();
		
		Usuario user = retrieveUser(userId);
		if (user != null) {
			retListaPublicaciones = user.getListaPublicaciones();
		}
		
		return retListaPublicaciones;
	}
	
	public static List retrievePublicaciones(Integer idZona, Integer idBarrio, Integer idUsuario) throws ApplicationException 
	{
		List retListaPublicaciones = new ArrayList();
		
		Iterator pu = publicaciones.iterator();
		while (pu.hasNext()) {
			Publicacion publicacion = (Publicacion)pu.next();
			if ((idZona != 0 && idZona.equals(publicacion.getZona().getIdZona())) ||
				(idBarrio != 0 && idBarrio.equals(publicacion.getBarrio().getBarrioPK().getIdBarrio())) ||
				(idUsuario != 0 && idUsuario.equals(publicacion.getIdUsuario())) ) {
				retListaPublicaciones.add(publicacion);
			}
		}
		
		return retListaPublicaciones;
	}
	
	public static List retrieveComentariosPublicacion(Integer idPublicacion) throws ApplicationException 
	{
		List retListaComentarios = new ArrayList();
		
		Iterator co = comentarios.iterator();
		while (co.hasNext()) {
			Comentario comentario = (Comentario)co.next();
			if (idPublicacion.equals(comentario.getIdPublicacion())) {
				retListaComentarios.add(comentario);
			}
		}
		
		return retListaComentarios;
	}
}
