package usecase;
 
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import control.interfaces.DataEntryUseCase;
import control.interfaces.UseCase;
import control.utility.ApplicationEvent;
import control.utility.ApplicationException;
import control.utility.ApplicationGlobals;
import control.utility.ApplicationStore;
import control.utility.BusinessGlobals;
import control.utility.DateComparator;
import control.utility.JSPDispatcher;
import control.utility.Logger;
import control.utility.Utility;
import database.hibernate.SystemHibernateDaoDbUtility;
import database.utility.HibernateUtil;
import entity.Dictionary;
import entity.Envelope;
import entity.hibernate.Publicacion;
import entity.hibernate.Usuario;

/*
 * **************************************************************************
 * <p>Welcome use case class
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */
 
public class Welcome implements UseCase, DataEntryUseCase 
{	
	protected ApplicationStore _appStore; 

	public Welcome(ApplicationStore appStore, Dictionary dicc) 
	{
		this._appStore = appStore;
	}
	
	public ApplicationEvent start() throws ApplicationException 
	{
		ApplicationEvent retAE = new ApplicationEvent();
		
		//build dto & store it in application event...
		//create envelope to jsp & redispatch...
		//set default window & layout...
		
		Envelope envelope = new Envelope(null);		
				
		retAE.setTarget(JSPDispatcher.getTarget(JSPDispatcher.Layout));	
		retAE.setDataModel(envelope);		
		retAE.setActiveUseCase(this);		
			
		return retAE;
	}

	public ApplicationEvent accept(ApplicationEvent appEvent, Dictionary dicc) throws ApplicationException 
	{
		String useCase = dicc.getSingleValue(ApplicationGlobals.SYSTEM_PARAM_ID_EVENT_USECASE);
		
		if (useCase.equals(new RegistrarUsuario(_appStore).getClass().getName())) {
			RegistrarUsuario registrarUsuario = new RegistrarUsuario(_appStore,null);
			return registrarUsuario.start();
		}
		else {
			DisplayMainLayout mainLayout = new DisplayMainLayout(_appStore,null);
			return mainLayout.start();
		}
	}
	
	public ApplicationEvent cancel(ApplicationEvent appEvent, Dictionary dicc) throws ApplicationException {
		return null;
	}
	 
}

