package control.navigation;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jfree.chart.servlet.ChartDeleter;

import control.utility.ApplicationEvent;
import control.utility.ApplicationGlobals;
import control.utility.ApplicationStore;

/*
 * **************************************************************************
 *  <p>Navigator Servlet implementation class
 *
 * --------------------------------------------------------------------------
 * @version     0.1 04/2013
 * @author      Fina Cara
 * --------------------------------------------------------------------------
 * **************************************************************************
 */

 public class Navigator extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	 
	private static final long serialVersionUID = 1239287723049772754L;
	protected ChartDeleter _chartDeleter = null;

	public Navigator() {
		super();
	}   	
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

	}  	
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

	}
	
	public void init() throws ServletException {		
		super.init();
		_chartDeleter = new ChartDeleter();
	}	
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		ApplicationStore as = new ApplicationStore(request.getSession());
		initializeSession(as, request);
		 
		ApplicationEvent ae = (ApplicationEvent) as.getEvent();
		if (ae != null) {
			ae.cleanErrors();
			_processEvent(as,request,response);
		}			
		dispatch(request,response,as);
	}

	private void _processEvent(ApplicationStore as, HttpServletRequest request, HttpServletResponse response){
		
		EventProcessor eventProcessor = new EventProcessor(as,request,response);
		eventProcessor.process();
		
		//Add temporaly image chart in deleter...
		ApplicationEvent appEvent = as.getEvent();
		if (appEvent!=null && appEvent.getTemporalFile()!=null){
			_chartDeleter.addChart(appEvent.getTemporalFile());
		}		
	}

	protected void initializeSession(ApplicationStore as, HttpServletRequest request) {
		
		//Check system already initialized...
		if (as.getObject(ApplicationGlobals.SYSTEM_INITIALIZATION_FLAG)==null){
			
			//Make login event in order to show login frame...
			ApplicationEvent aeLogin = new ApplicationEvent();
			request.setAttribute(ApplicationGlobals.SYSTEM_PARAM_ID_EVENT,ApplicationGlobals.SYSTEM_APPLICATION_EVENT_LOGIN);
			as.setEvent(aeLogin);
			
			//Set initialization flag to yes...
			as.addObject(ApplicationGlobals.SYSTEM_INITIALIZATION_FLAG, "Y");
		}
	}
	 
	public void dispatch(HttpServletRequest request,HttpServletResponse response, ApplicationStore appStore){
		
		ApplicationEvent appEvent = (ApplicationEvent)appStore.getEvent();

		if (appEvent != null && appEvent.getTarget()!=null)
		{	
			dispatch(request, response, appEvent.getTarget());
		}
		else{
			if(appEvent != null && appEvent.getXmlResponse()!=null){
				response.setHeader("content-type", "text/xml");
				try {
					response.getOutputStream().print(appEvent.getXmlResponse());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private void dispatch(HttpServletRequest request,HttpServletResponse response,String url){
		RequestDispatcher rd = getServletContext().getRequestDispatcher(url);
		try{
			rd.forward(request, response);
		}
		catch(ServletException e){
			e.printStackTrace();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
}